from cryptography.fernet import Fernet
import rdm6300

# Generate a key for encryption and decryption
key = Fernet.generate_key()
cipher_suite = Fernet(key)

# RFID card chip id to allow decryption
allowed_chip_id = 53346

# Function to unlock and decrypt the data from a locked file
def unlock_and_decrypt(filename, rfid_chip_id):
    with open(filename, 'rb') as file:
        encrypted_data = file.read()

    if rfid_chip_id == allowed_chip_id:
        decrypted_data = cipher_suite.decrypt(encrypted_data).decode()
        print(f"Decrypted Data: {decrypted_data}")
    else:
        print("Unauthorized access. The correct RFID card is required for decryption.")

# Function to scan RFID card chip
def scan_rfid():
    reader = rdm6300.Reader('/dev/ttyS0')
    print("Please scan your RFID card...")
    while True:
        card = reader.read()
        if card:
            return card.value

# Example usage: Scan RFID card to unlock and decrypt the data
scanned_chip_id = scan_rfid()
encrypted_file = 'locked_file.txt'

unlock_and_decrypt(encrypted_file, scanned_chip_id)
